var sites = 0;
var username;
var loggedin = false;
var checker;
var process = 0;

$(document).on("click", "a", function() {
	if($(this).attr("id") == "logout") {
		logout();
	} else if($(this).attr("id") == "redeem") {
		$.get('redeem&' + username, function(data) {
			if(data == 1) {
				$('#message').html('<div class="alert alert-success">Succesfully redeemed!</div>');
				$('#redeem').html('<a class="btn btn-success">Come back tomorrow!</button>');
			} else {
				$('#message').html('<div class="alert alert-danger">Failed to redeem! Are you online?</div>');
			}
		});
	}
});

function loadPage() {
	restoreLogin();
	if(!loggedin) {
		loadLogin();
	} else {
		loadVote();
	}
	loadToplist();
}

function loadLogin() {
	$('#head').html(
		'<center><form class="form-inline" role="form" action="#" method="post" onsubmit="login(this.name.value); return false;">' +
		'<div class="form-group">' +
		'<label for="name">Welcome, please log in</label>' +
		'<input type="text" class="form-control" id="name" placeholder="Username" name="name">' +
		'</div><br><br>' +
		'<input type="submit" class="btn btn-default value="Login" />' +
		'</form></center>'
	);
}

function loadVote() {
	$('#sites').show();
	YAML.fromURL("config.yml", function(data) {
		if(checker == null) {
			sites = data['sites'].length;
			$('#head').html(
				'<center>' +
				'Welcome ' + username + ', <a href="javascript:void(0)" id="logout">Logout</a>' +
				'</center>'
			);
			for (var i = 0; i < sites; i++) {
				var site = data['sites'][i];
				$('#sites tbody').append(
					'<tr>' +
					'<td><li><a href="site&' + i + '&' + username + '" target="_blank">' + site['name'] + '</a></li></td>' +
					'<td id="site' + i + '"></td>' +
					'</tr>'
				);
			}
			checkVoted();
			checker = setInterval("checkVoted()", 5000);
		}
	});
}

function loadToplist() {
	$.get('toplist', function(data) {
		var topList = data.split("|");
		YAML.fromURL("config.yml", function(data) {
			var tbody;
			for(var i=0; i < data['general']['showTop']; i++) {
				tbody +=
					'<tr>' +
					'<td>' +
					[i + 1] +
					'</td>' +
					'<td>' +
					topList[i * 2] +
					'</td>' +
					'<td>' +
					topList[i * 2 + 1] +
					'</td>' +
					'</tr>'
			}
			$('#top tbody').html(tbody);
		});
	});
}

function checkVoted() {
	$.get('hasvoted&' + username, function(data) {
		if(data == -1) {
			clearInterval(checker);
			for(var i=0; i < sites; i++) {
				if($('#site' + i).is(':empty')) {
					$('#site' + i).html('<img src="images/success.gif">');
				}
			}
			$('#redeem').html(
				'<a class="btn btn-success">Come back tomorrow!</button>'
			);
		} else {
			var voted = data.split("|");
			var c = 0;
			for(var i=0; i < sites; i++) {
				if(data[i*2] == "1") {
					if($('#site' + i).is(':empty')) {
						$('#site' + i).html('<img src="images/success.gif">');
					}
					c++
				}
			}
			var percent = c / sites * 100;
			if(percent > 100) {
				percent = 100;
			}
			if(percent == 0) {
				percent = 5;
			}
			
			if(percent > process) {
				$('#redeem').html(
					'<div class="progress progress-striped active">' +
					'<div class="progress-bar" role="progressbar" aria-valuenow="45" aria-valuemin="0" aria-valuemax="100" style="width: ' + percent + '%">' +
					'</div>' +
					'</div>'
				);
				process = percent;
			}
			
			if(percent == 100) {
				clearInterval(checker);
				$('#redeem').html(
					'<a href="javascript:void(0)" id="redeem" href="redeem&' + username + '" class="btn btn-success">Redeem!</button>'
				);
			}
		}
	});
}

function login(name) {
	createCookie("username",name,365);
	
	username = name;
	loggedin = true;
	loadVote();
}

function logout() {
	eraseCookie("username");	
	location.reload(true);
}

function restoreLogin() {
	if(readCookie("username") != null) {
		username = readCookie("username");
		loggedin = true;
	}
}

function createCookie(name,value,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    }
    else var expires = "";
    document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name,"",-1);
}

window.onload = loadPage;